unit frmMain;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, ExtCtrls,
  Windows;

const
  //
  // Stale ograniczajace rozmiar bufora grafiki.
  //
  maxBufferX = 1920 ;
  maxBufferY = 1080 ;


type

  { TMain }

  //
  // Typy pomocnicze na potrzeby grafiki buforowanej
  // Twój bufor ekranu jeden typ liniowy, drugi z dostępem do poszczególnych składowych kolorów.
  // W poważnym programie powinny to być tablice dynamiczne ale dla ulatwienia zastosuje statyczne.
  //
  TScreen = array [ 0 .. maxBufferX*maxBufferY ] of Dword ; // planujemy układ kolorów RGBA
  TScreenRGBA = Array [ 0 .. maxBufferX*maxBufferY ] of record
    R, G, B, A :byte ;
  end ;

  TMain = class(TForm)
    btnRysuj: TButton;
    drawPanel: TPanel;
    procedure btnRysujClick(Sender: TObject);
  private

    //
    // Zmienne na potrzeby bufora grafiki
    //
    canvasHandle : HWND ;
    bmpinf:TBitmapInfoHeader;
    bmpin:TBitmapInfo;
    rgbq:array [0..0] of TRGBQuad;
    maxX, maxY : integer;

  public


    //
    // Bufor trzymam sobie globalnie ...
    //
    screen : TScreen ;
    screenRGBA : ^TScreenRGBA; // absolute rzutuje obszar pamięci na Screen


    procedure Rysuj;
  end;

var
  Main: TMain;

implementation

{$R *.lfm}

{ TMain }

procedure TMain.Rysuj;
var
  x, y : integer ;
begin

  //
  // Inicjujemy niezbędne struktury opisujące parametry bufora obrazu
  //
  canvasHandle := self.drawPanel.Handle ; // Tu przypisać HWND okna w którym rysujemy.
  maxX := self.drawPanel.width ;
  maxY := self.drawPanel.height ;

  bmpinf.bisize:=sizeof(bmpinf);
  bmpinf.biwidth:= maxX ;
  bmpinf.biheight:= maxY ;
  bmpinf.biplanes:=1;
  bmpinf.bibitcount:=32;
  bmpinf.bicompression:=0;
  bmpinf.bisizeimage:=0;
  bmpinf.biXpelspermeter:=0;
  bmpinf.biYpelspermeter:=0;
  bmpinf.biclrused:=0;
  bmpinf.biclrimportant:=0;
  rgbq[0].rgbblue:=1;
  rgbq[0].rgbgreen:=2;
  rgbq[0].rgbred:=3;
  rgbq[0].rgbreserved:=0;
  bmpin.bmiheader:=bmpinf;
  bmpin.bmicolors[0]:=rgbq[0];

  //
  // Tutaj rysujesz cokolwiek w bufrze ...
  // np. wypełnienie losowymi odcieniami niebieskiego
  //

  ScreenRGBA := @screen[0];
  for x := 0 to maxX - 1 do
  for y := 0 to maxY - 1 do
  begin
    ScreenRGBA^ [ x + maxX * Y ].R := random(255);
  end;

  //
  // Wyrzucasz na ekran / do okna.
  //
  SetDIBitsToDevice( GetDc ( canvasHandle ), 0, 0 ,maxX, maxY, 0, 0, 0, maxY, @Screen[0], bmpin,DIB_RGB_COLORS ) ;

end;

procedure TMain.btnRysujClick(Sender: TObject);
begin
  self.Rysuj;
end;

end.

